src/Project-Showcase/project-archive/solution/app/models/order.py
from .db import db


class Order(db.Model):
    __tablename__ = "orders"

    id = db.Column(db.Integer, primary_key=True)
    employee_id = db.Column(db.Integer,
                            db.ForeignKey("employees.id"),
                            nullable=False)
    table_id = db.Column(db.Integer,
                         db.ForeignKey("tables.id"),
                         nullable=False)
    finished = db.Column(db.Boolean, nullable=False)

    employee = db.relationship("Employee", back_populates="orders")
    table = db.relationship("Table", back_populates="orders")
    details = db.relationship("OrderDetail", back_populates="order")

    @property
    def total(self):
        return sum([detail.menu_item.price for detail in self.details])

src/Project-Showcase/project-archive/solution/app/routes/orders.py
from flask import Blueprint, redirect, render_template, url_for
from flask_login import current_user, login_required
from app.models import (
    Employee, MenuItem, MenuItemType, Order, OrderDetail, Table, db
)
from ..forms import MenuItemAssignmentForm, TableAssignmentForm
from sqlalchemy.orm import joinedload

bp = Blueprint("orders", __name__, url_prefix="")


@bp.route("/orders/<int:id>/items", methods=["POST"])
@login_required
def add_to_order(id):
    form = MenuItemAssignmentForm()
    form.menu_item_ids.choices = [(item.id, '')
                                  for item in MenuItem.query.all()]
    from pprint import pprint
    pprint(form.menu_item_ids.choices)
    if form.validate_on_submit():
        order = Order.query.get(id)
        for menu_item_id in form.menu_item_ids.data:
            detail = OrderDetail(order=order, menu_item_id=menu_item_id)
            db.session.add(detail)
        db.session.commit()
    return redirect(url_for('.index'))


@bp.route("/assignments", methods=["POST"])
@login_required
def assign():
    form = TableAssignmentForm()
    open_tables, servers = open_tables_and_servers()
    form.tables.choices = [(t.id, f"Table {t.number}") for t in open_tables]
    form.employees.choices = [(e.id, e.name) for e in servers]
    if form.validate_on_submit():
        order = Order(
            employee_id=form.employees.data,
            table_id=form.tables.data,
            finished=False
        )
        db.session.add(order)
        db.session.commit()
    return redirect(url_for('.index'))


@bp.route("/finalization/<int:id>", methods=["POST"])
@login_required
def close(id):
    order = Order.query.get(id)
    order.finished = True
    db.session.commit()
    return redirect(url_for('.index'))


@bp.route("/")
@login_required
def index():
    taf = TableAssignmentForm()
    open_tables, servers = open_tables_and_servers()
    taf.tables.choices = [(t.id, f"Table {t.number}") for t in open_tables]
    taf.employees.choices = [(e.id, e.name) for e in servers]

    open_orders = Order.query.filter(
        Order.finished == False and Order.employee_id == current_user.id
    ).options(joinedload(Order.table)).options(joinedload(Order.details, OrderDetail.menu_item))

    foods = MenuItem.query.join(MenuItemType).order_by(MenuItemType.name, MenuItem.name).options(joinedload(MenuItem.type))
    foods_by_type = {}
    for food in foods:
        if food.type.name not in foods_by_type:
            foods_by_type[food.type.name] = []
        foods_by_type[food.type.name].append(food)

    data = {'taf': taf, 'orders': open_orders, 'foods_by_type': foods_by_type}
    return render_template("orders.html", **data)


def open_tables_and_servers():
    tables = Table.query.order_by(Table.number)
    open_orders = Order.query.filter(Order.finished == False)
    busy_table_ids = [order.table_id for order in open_orders]
    open_tables = [table for table in tables if table.id not in busy_table_ids]
    servers = Employee.query.all()
    return open_tables, servers

src/Project-Showcase/project-archive/solution/app/routes/session.py
from flask import Blueprint, redirect, render_template, url_for
from flask_login import current_user, login_user, logout_user
from ..forms import LoginForm
from ..models import Employee

bp = Blueprint("session", __name__, url_prefix="/session")


@bp.route("/", methods=["GET", "POST"])
def login():
    if current_user.is_authenticated:
        return redirect(url_for("orders.index"))
    form = LoginForm()
    from pprint import pprint
    pprint(form.data)
    if form.validate_on_submit():
        n = form.employee_number.data
        employee = Employee.query.filter(Employee.employee_number == n).first()
        if not employee or not employee.check_password(form.password.data):
            return redirect(url_for(".login"))
        login_user(employee)
        return redirect(url_for("orders.index"))
    return render_template("login.html", form=form)


@bp.route('/logout', methods=["POST"])
def logout():
    logout_user()
    return redirect(url_for('.login'))

src/Project-Showcase/project-archive/solution/app/routes/simple.py
from flask import Blueprint, redirect, render_template
from ..forms import SimpleForm
from ..models import db, SimplePerson

bp = Blueprint("simple", __name__, "")


@bp.route("/")
def main_page():
    return render_template("main_page.html")


@bp.route("/simple-form")
def simple_form():
    form = SimpleForm()
    return render_template("simple_form.html", form=form)


@bp.route("/simple-form", methods=["POST"])
def simple_data():
    form = SimpleForm()
    if form.validate_on_submit():
        data = SimplePerson()
        form.populate_obj(data)
        db.session.add(data)
        db.session.commit()
        return redirect("/")
    print(form.errors)
    return "Bad Data"


@bp.route("/simple-form-data")
def simple_form_data():
    result = SimplePerson.query.filter(SimplePerson.name.like("M%")).all()
    return render_template("simple_form_data.html", result=result)

src/Project-Showcase/project-archive/solution/app/templates/base.html
<html>
  <head>
    <link rel="stylesheet" href="/static/order-up.css" />
    {% if title %}
    <title>{{ title }} - Order Up!</title>
    {% else %}
    <title>Welcome to Order Up!</title>
    {% endif %}
  </head>
  <body>
    {% block content %}{% endblock %}
  </body>
</html>

src/Project-Showcase/project-archive/solution/app/templates/login.html
{% extends "base.html" %} {% block content %}
<form method="post" action="{{ url_for('.login') }}">
  {{ form.csrf_token }}
  <div>
    {{ form.employee_number.label }} {{ form.employee_number }} {% if
    form.employee_number.errors %}
    <ul>
      {% for error in form.employee_number.errors %}
      <li>{{ error }}</li>
      {% endfor %}
    </ul>
    {% endif %}
  </div>
  <div>
    {{ form.password.label }} {{ form.password }} {% if
    form.employee_number.errors %}
    <ul>
      {% for error in form.employee_number.errors %}
      <li>{{ error }}</li>
      {% endfor %}
    </ul>
    {% endif %}
  </div>
  <div>{{ form.submit }}</div>
</form>
{% endblock %}

src/Project-Showcase/project-archive/solution/app/templates/main.html
<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="UTF-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <link rel="stylesheet" href="/static/styles/calendar.css" />
    <script src="/static/scripts/calendar.js"></script>
    <title>Calendar This!</title>
  </head>
  <body>
    <div id="application">
      <section id="appointment-form">
        <form method="post">
          {{ form.csrf_token }}
          <div class="form-row">{{ form.name.label }} {{ form.name }}</div>
          <div class="form-row">
            {{ form.start_date.label }} {{ form.start_date }}
          </div>
          <div class="form-row">
            {{ form.start_time.label }} {{ form.start_time }}
          </div>
          <div class="form-row">
            {{ form.end_date.label }} {{ form.end_date }} {% if
            form.end_date.errors %}
            <ul class="errors">
              {% for error in form.end_date.errors %}
              <li>{{ error }}</li>
              {% endfor %}
            </ul>
            {% endif %}
          </div>
          <div class="form-row">
            {{ form.end_time.label }} {{ form.end_time }}
          </div>
          <div class="form-row">
            {{ form.description.label }} {{ form.description }}
          </div>
          <div class="form-row">
            {{ form.private.label }} {{ form.private }}
          </div>
          <div class="form-actions">{{ form.submit }}</div>
        </form>
      </section>
      <main>
        <div class="selector">
          <input type="date" id="date-selector"
          value="{{day.strftime("%Y-%m-%d")}}">
        </div>
        {% for slot in timeslots %}
        <div>{{ slot.time.strftime("%H:%M") }}</div>
        {% if slot.appointment %}
        <div
          class="appointment"
          style="grid-row-end: span {{ slot.appointment.units }};"
        >
          {{ slot.appointment.name }}
        </div>
        {% elif slot.open %}
        <div></div>
        {% endif %} {% endfor %}
      </main>
    </div>
  </body>
</html>

src/Project-Showcase/project-archive/solution/app/templates/main_page.html
<h1>Practice Assessment</h1>

src/Project-Showcase/project-archive/solution/app/templates/orders.html
{% extends "base.html" %} {% block content %}
<div id="workspace">
  <header class="actions-header">
    <form
      class="assignment-form"
      method="post"
      action="{{ url_for('.assign') }}"
    >
      {{ taf.csrf_token }}
      <div class="assignment-form-title">Assign Table</div>
      <div class="assignment-form-select">{{ taf.tables }}</div>
      <div class="assignment-form-select">{{ taf.employees }}</div>
      <div class="assignment-form-submit">
        {{ taf.assign(class="button assign") }}
      </div>
    </form>
    <form
      class="logout-form"
      method="post"
      action="{{ url_for('session.logout') }}"
    >
      <button class="logout">Logout</button>
    </form>
  </header>
  <main>
    <table class="orders-table">
      <thead>
        <tr>
          <th colspan="4" class="table-title">Your Open Orders</th>
        </tr>
      </thead>
      <tbody>
        {% for order in orders %}
        <tr class="order-row">
          <td>Table {{ order.table.number }}</td>
          <td>{{ "${:,.2f}".format(order.total) }}</td>
          <td class="order-action-cell">
            <form method="post" action="{{ url_for('.close', id=order.id) }}">
              {{ taf.csrf_token }}
              <button class="micro">Close table</button>
            </form>
          </td>
          <td class="order-action-cell">
            <button
              class="micro"
              form="food-list"
              formaction="{{ url_for('.add_to_order', id=order.id) }}"
            >
              Add to order
            </button>
          </td>
        </tr>
        {% endfor %}
      </tbody>
    </table>
    <aside class="food-list">
      <form id="food-list" method="post">
        {% for type, foods in foods_by_type.items() %} {{ taf.csrf_token }}
        <section class="food-type-group">
          <header class="food-type-header">{{ type }}</header>
          <div class="foods">
            {% for food in foods %}
            <div class="food-choice">
              <input
                type="checkbox"
                name="menu_item_ids"
                value="{{ food.id }}"
              />
              {{ food.name }}
            </div>
            {% endfor %}
          </div>
        </section>
        {% endfor %}
      </form>
    </aside>
  </main>
</div>
{% endblock %}

src/Project-Showcase/project-archive/solution/app/templates/simple_form.html
<form method="post" action="/simple-form">
  {{ form.csrf_token }}
  <div>{{ form.name.label }} {{ form.name }}</div>
  <div>{{ form.age.label }} {{ form.age }}</div>
  <div>{{ form.bio.label }} {{ form.bio }}</div>
  <div>{{ form.submit }}</div>
</form>

src/Project-Showcase/project-archive/solution/app/templates/simple_form_data.html
{% for data in result %}
<div>{{ data.name }}</div>
<div>{{ data.age }}</div>
<div>{{ data.bio }}</div>
{% endfor %}